<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/assign_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>02/08/84  assign_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>Entry points in assign_:
<span id="L5" class="LineNr">  5 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>:Entry: assign_: 02/08/84  assign_
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>Function: assigns a specified source value to a specified target.
<span id="L11" class="LineNr"> 11 </span>This subroutine handles the following data types: 1-12, 19-22, 33, 34,
<span id="L12" class="LineNr"> 12 </span>41-46.  Any other type will produce an error.  It uses rounding in the
<span id="L13" class="LineNr"> 13 </span>conversion when the target is floating point or when the source is
<span id="L14" class="LineNr"> 14 </span>floating and the target is character, and uses truncation in all other
<span id="L15" class="LineNr"> 15 </span>cases.
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>
<span id="L18" class="LineNr"> 18 </span>Syntax:
<span id="L19" class="LineNr"> 19 </span>declare assign_ entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L20" class="LineNr"> 20 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L21" class="LineNr"> 21 </span>call assign_ <span class="textRainbow_lv0_p0">(</span>target_ptr<span class="textRainbow_lv0_o0">,</span> target_type<span class="textRainbow_lv0_o0">,</span> target_length<span class="textRainbow_lv0_o0">,</span> source_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L22" class="LineNr"> 22 </span>     source_type<span class="textRainbow_lv0_o0">,</span> source_length<span class="textRainbow_lv0_p0">)</span>;
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>
<span id="L25" class="LineNr"> 25 </span>Arguments:
<span id="L26" class="LineNr"> 26 </span>target_ptr
<span id="L27" class="LineNr"> 27 </span>   points to the target of the assignment; it can contain a bit offset.
<span id="L28" class="LineNr"> 28 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L29" class="LineNr"> 29 </span>target_type
<span id="L30" class="LineNr"> 30 </span>   specifies the type of the target; its value is 2*M+P where M is the
<span id="L31" class="LineNr"> 31 </span>   Multics standard data type code <span class="textRainbow_lv0_p0">(</span>see the Programmer's Reference
<span id="L32" class="LineNr"> 32 </span>   Manual<span class="textRainbow_lv0_p0">)</span> and P is 0 if the target is unpacked and 1 if the target is
<span id="L33" class="LineNr"> 33 </span>   packed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L34" class="LineNr"> 34 </span>
<span id="L35" class="LineNr"> 35 </span>
<span id="L36" class="LineNr"> 36 </span>target_length
<span id="L37" class="LineNr"> 37 </span>   is the string length or arithmetic scale and precision of the
<span id="L38" class="LineNr"> 38 </span>   target.  If the target is arithmetic, the target_length word
<span id="L39" class="LineNr"> 39 </span>   consists of two adjacent unaligned halfwords.  The left halfword is
<span id="L40" class="LineNr"> 40 </span>   a fixed bin<span class="textRainbow_lv0_p0">(</span>17<span class="textRainbow_lv0_p0">)</span> representing the signed scale and the right halfword
<span id="L41" class="LineNr"> 41 </span>   is a fixed bin<span class="textRainbow_lv0_p0">(</span>18<span class="textRainbow_lv0_p0">)</span> unsigned integer representing the precision.
<span id="L42" class="LineNr"> 42 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The include file encoded_precision.incl.pl1 declares this
<span id="L43" class="LineNr"> 43 </span>   as:
<span id="L44" class="LineNr"> 44 </span>      dcl 1 encoded_precision  based aligned,
<span id="L45" class="LineNr"> 45 </span>            2 scale            fixed bin<span class="textRainbow_lv0_p0">(</span>17<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L46" class="LineNr"> 46 </span>            2 prec             fixed bin<span class="textRainbow_lv0_p0">(</span>18<span class="textRainbow_lv0_p0">)</span> unsigned unaligned;
<span id="L47" class="LineNr"> 47 </span>
<span id="L48" class="LineNr"> 48 </span>
<span id="L49" class="LineNr"> 49 </span>source_ptr
<span id="L50" class="LineNr"> 50 </span>   points at the source of the assignment; it can contain a bit offset.
<span id="L51" class="LineNr"> 51 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L52" class="LineNr"> 52 </span>source_type
<span id="L53" class="LineNr"> 53 </span>   specifies the source type using the same format as target_type.
<span id="L54" class="LineNr"> 54 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L55" class="LineNr"> 55 </span>source_length
<span id="L56" class="LineNr"> 56 </span>   is the string length or arithmetic scale and precision of the source
<span id="L57" class="LineNr"> 57 </span>   using the same format as target_length.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L58" class="LineNr"> 58 </span>
<span id="L59" class="LineNr"> 59 </span>
<span id="L60" class="LineNr"> 60 </span>:Entry:  computational_:  02/08/84 assign_$computational_
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>
<span id="L63" class="LineNr"> 63 </span>Function: assigns a specified source value to a specified target.  It
<span id="L64" class="LineNr"> 64 </span>can handle any computational Multics data type including all PL/I
<span id="L65" class="LineNr"> 65 </span>computational data and all COBOL and FORTRAN data types.  This entry
<span id="L66" class="LineNr"> 66 </span>uses the same rules for rounding and truncation as assign_.
<span id="L67" class="LineNr"> 67 </span>
<span id="L68" class="LineNr"> 68 </span>
<span id="L69" class="LineNr"> 69 </span>Syntax:
<span id="L70" class="LineNr"> 70 </span>declare assign_$computational_ entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L71" class="LineNr"> 71 </span>call assign_$computational_ <span class="textRainbow_lv0_p0">(</span>tar_str_ptr<span class="textRainbow_lv0_o0">,</span> src_str_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L72" class="LineNr"> 72 </span>
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>Arguments:
<span id="L75" class="LineNr"> 75 </span>tar_str_ptr
<span id="L76" class="LineNr"> 76 </span>   is a pointer to a structure which defines the address and attributes
<span id="L77" class="LineNr"> 77 </span>   of the target.  The format of this structure is defined in
<span id="L78" class="LineNr"> 78 </span>   computational_data.incl.pl1.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L79" class="LineNr"> 79 </span>src_str_ptr
<span id="L80" class="LineNr"> 80 </span>   is a pointer to a structure giving the attributes of the source.
<span id="L81" class="LineNr"> 81 </span>   This structure has the same format as the one used for the target.
<span id="L82" class="LineNr"> 82 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L83" class="LineNr"> 83 </span>code
<span id="L84" class="LineNr"> 84 </span>   is a standard system code.  It will be zero if the conversion was
<span id="L85" class="LineNr"> 85 </span>   sucessful, or error_table_$bad_conversion if either data type was
<span id="L86" class="LineNr"> 86 </span>   not computational.  It is also possible that the conversion
<span id="L87" class="LineNr"> 87 </span>   condition will be signalled, if the source data can not be converted
<span id="L88" class="LineNr"> 88 </span>   to the requested target type.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>:Entry:  assign_round_:  02/08/84 assign_$assign_round_
<span id="L92" class="LineNr"> 92 </span>
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>Function: assigns a source value to a target value, but always rounds.
<span id="L95" class="LineNr"> 95 </span>Otherwise it is identical to assign_.
<span id="L96" class="LineNr"> 96 </span>
<span id="L97" class="LineNr"> 97 </span>
<span id="L98" class="LineNr"> 98 </span>Syntax:
<span id="L99" class="LineNr"> 99 </span>declare assign_$assign_round_ entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L100" class="LineNr">100 </span>     ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L101" class="LineNr">101 </span>call assign_$assign_round_ <span class="textRainbow_lv0_p0">(</span>target_ptr<span class="textRainbow_lv0_o0">,</span> target_type<span class="textRainbow_lv0_o0">,</span> target_length<span class="textRainbow_lv0_o0">,</span>
<span id="L102" class="LineNr">102 </span>     source_ptr<span class="textRainbow_lv0_o0">,</span> source_type<span class="textRainbow_lv0_o0">,</span> source_length<span class="textRainbow_lv0_p0">)</span>;
<span id="L103" class="LineNr">103 </span>
<span id="L104" class="LineNr">104 </span>
<span id="L105" class="LineNr">105 </span>Arguments:
<span id="L106" class="LineNr">106 </span>target_ptr
<span id="L107" class="LineNr">107 </span>   points to the target of the assignment; it can contain a bit offset.
<span id="L108" class="LineNr">108 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L109" class="LineNr">109 </span>target_type
<span id="L110" class="LineNr">110 </span>   specifies the type of the target.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L111" class="LineNr">111 </span>target_length
<span id="L112" class="LineNr">112 </span>   is the string length or arithmetic scale and precision of the
<span id="L113" class="LineNr">113 </span>   target.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L114" class="LineNr">114 </span>
<span id="L115" class="LineNr">115 </span>
<span id="L116" class="LineNr">116 </span>source_ptr
<span id="L117" class="LineNr">117 </span>   points at the source of the assignment; it can contain a bit offset.
<span id="L118" class="LineNr">118 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L119" class="LineNr">119 </span>source_type
<span id="L120" class="LineNr">120 </span>   specifies the source type using the same format as target_type.
<span id="L121" class="LineNr">121 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L122" class="LineNr">122 </span>source_length
<span id="L123" class="LineNr">123 </span>   is the string length or arithmetic scale and precision of the source
<span id="L124" class="LineNr">124 </span>   using the same format as target_length.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L125" class="LineNr">125 </span>
<span id="L126" class="LineNr">126 </span>
<span id="L127" class="LineNr">127 </span>:Entry:  assign_truncate_:  02/08/84 assign_$assign_truncate_
<span id="L128" class="LineNr">128 </span>
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>Function: assigns a source value to a target value, but always
<span id="L131" class="LineNr">131 </span>truncates.  Otherwise it is identical to assign_.
<span id="L132" class="LineNr">132 </span>
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>Syntax:
<span id="L135" class="LineNr">135 </span>declare assign_$assign_truncate_ entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L136" class="LineNr">136 </span>     ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L137" class="LineNr">137 </span>call assign_$assign_truncate_ <span class="textRainbow_lv0_p0">(</span>target_ptr<span class="textRainbow_lv0_o0">,</span> target_type<span class="textRainbow_lv0_o0">,</span> target_length<span class="textRainbow_lv0_o0">,</span>
<span id="L138" class="LineNr">138 </span>     source_ptr<span class="textRainbow_lv0_o0">,</span> source_type<span class="textRainbow_lv0_o0">,</span> source_length<span class="textRainbow_lv0_p0">)</span>;
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>Arguments:
<span id="L142" class="LineNr">142 </span>target_ptr
<span id="L143" class="LineNr">143 </span>   points to the target of the assignment; it can contain a bit offset.
<span id="L144" class="LineNr">144 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L145" class="LineNr">145 </span>target_type
<span id="L146" class="LineNr">146 </span>   specifies the type of the target.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L147" class="LineNr">147 </span>target_length
<span id="L148" class="LineNr">148 </span>   is the string length or arithmetic scale and precision of the
<span id="L149" class="LineNr">149 </span>   target.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L150" class="LineNr">150 </span>
<span id="L151" class="LineNr">151 </span>
<span id="L152" class="LineNr">152 </span>source_ptr
<span id="L153" class="LineNr">153 </span>   points at the source of the assignment; it can contain a bit offset.
<span id="L154" class="LineNr">154 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L155" class="LineNr">155 </span>source_type
<span id="L156" class="LineNr">156 </span>   specifies the source type using the same format as target_type.
<span id="L157" class="LineNr">157 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L158" class="LineNr">158 </span>source_length
<span id="L159" class="LineNr">159 </span>   is the string length or arithmetic scale and precision of the source
<span id="L160" class="LineNr">160 </span>   using the same format as target_length.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
